import numpy as np
from .base_kernel import BaseArbiterKernel


class LitFrames(BaseArbiterKernel):
    @staticmethod
    def extend_device_schema(schema, prefix):
        pass

    def consider(self, train_id, sources, num_frames, mask, out_hash):
        for source, (data, _) in sources.items():
            if not data.has("data.nPulsePerFrame"):
                continue

            lff_data = np.array(data["data.nPulsePerFrame"])
            if len(lff_data) != num_frames:
                raise ValueError(
                    f"{source}'s nPulsesPerFrame had weird size {len(lff_data)}; "
                    f"I think there should be {num_frames} frames!"
                )
            return lff_data > 0
        raise KeyError("No source had 'data.nPulsesPerFrame'")
